//---------------------------------------------------------------------------

#include <vcl.h>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


//      
class MeanValue {
  private:
    long num;    //  
    long sum;    //    
  public:
    // 
    MeanValue () : num(0), sum(0) {
    }

    // " "
    // -    
    void operator() (int elem) {
        num++;          //  
        sum += elem;    //  
    }

    //   
    // (   )
    operator double() {
        return static_cast<double>(sum) / static_cast<double>(num);
    }
};

int main()
{
  vector<int> coll;

  INSERT_ELEMENTS(coll,1,8);

  PRINT_ELEMENTS(coll," :\n");

  //     
  double mv = for_each (coll.begin(), coll.end(),  // 
                        MeanValue());              // 
  cout << ToRus(" : ") << mv << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------